/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 22.05.2016
Author  : PerTic@n
Company : If You Like This Software,Buy It
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 4,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>


#define   SWAP(A, B) {int t = A; A = B; B = t;}
#define   SetBit(reg, bit)          reg |= (1<<bit)            
#define   ResBit(reg, bit)          reg &= (~(1<<bit))
#define   InvBit(reg, bit)          reg ^= (1<<bit)
#define   BitIsSet(reg, bit)        ((reg & (1<<bit)) != 0)
#define   BitIsClear(reg, bit)      ((reg & (1<<bit)) == 0)


//========== ===============
#define CC
//========== ================
//#define CA


unsigned int adc_data;
#define ADC_VREF_TYPE 0x00

#ifdef CC
flash char digits[] = {       
0b00111111,                   //0  0
0b00000110,                   //1  1
0b01011011,                   //2  2
0b01001111,                   //3  3
0b01100110,                   //4  4
0b01101101,                   //5  5
0b01111101,                   //6  6
0b00000111,                   //7  7
0b01111111,                   //8  8
0b01101111,                   //9  9
0b00111110                    //10 U
};
#endif

#ifdef CA
flash char digits[] = {       
0b11000000,                   //0  0
0b11111001,                   //1  1
0b10100100,                   //2  2
0b10110000,                   //3  3
0b10011001,                   //4  4
0b10010010,                   //5  5
0b10000010,                   //6  6
0b11111000,                   //7  7
0b10000000,                   //8  8
0b10010000,                   //9  9
0b11000001                    //10 U
};
#endif

volatile unsigned char led_buf[4];
volatile unsigned int volt;
static char rzd = 0;


// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
// Place your code here
#ifdef CC
  PORTD=PORTD|0b00001111; //
  InvBit(PORTD, rzd);
  PORTB=digits[led_buf[rzd]];
  if (rzd==1) PORTB.7=1;
  rzd++;
  if (rzd==4) rzd = 0;
#endif

#ifdef CA
  PORTD=PORTD&0b11110000;
  InvBit(PORTD, rzd);
  PORTB=digits[led_buf[rzd]]; //   ,     led_buf[0]  led_buf[3]
  if (rzd==1) PORTB.7=0;
  rzd++;
  if (rzd==4) rzd=0;
#endif
  TCNT0=0x80; 
}


// ADC interrupt service routine
interrupt [ADC_INT] void adc_isr(void)
{
// Read the AD conversion result
adc_data=ADCW;
}

// Read the AD conversion result
// with noise canceling
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
#asm
    in   r30,mcucr
    cbr  r30,__sm_mask
    sbr  r30,__se_bit | __sm_adc_noise_red
    out  mcucr,r30
    sleep
    cbr  r30,__se_bit
    out  mcucr,r30
#endasm
return adc_data;
}

// Declare your global variables here

unsigned int real_ADC(char chanal)
{
  unsigned char i,j,f = 0;
  unsigned int mass[64];
  unsigned int tmp = 0;
  for (i=0; i<64; i++) //  64  
  {
    mass[i] = read_adc(chanal); 
    delay_ms(50);
  };

  for (i = 63; i > 0; i--) //  
  {
    f = 0;
    for (j = 0; j < i; j++)
    {
      if (mass[j] > mass[j + 1])
      {
        SWAP( mass[j], mass[j + 1] );
        f = 1;
      }
    }
    if (f == 0) break;
  }
  tmp = 0;
  for (i=16; i<48; i++) tmp = tmp + mass[i]; //  16   16  
                                             //    32- 
  return tmp>>6;
}


void dig_to_char(void)
{
     led_buf[0] = volt/100%10;
     led_buf[1] = volt/10%10;
     led_buf[2] = volt/1%10;
     led_buf[3] = 10;
};

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=T State3=0 State2=0 State1=0 State0=0 
PORTD=0x00;
DDRD=0x0F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
TCCR0=0x04;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 62,500 kHz
// ADC Voltage Reference: Int., cap. on AREF
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x8E;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here 
      volt = (int)((real_ADC(0)*0.9 + 0.1*volt)*1.02);// 
      dig_to_char();
      }
}